/* $Id: close.c,v 1.3 1998/07/13 00:39:39 martin Exp $ */

/* Copyright (C) 1995, 1996, 1997 Free Software Foundation, Inc.
   This file is part of the Gnome Top Library.
   Contributed by Martin Baulig <martin@home-of-linux.org>, April 1998.

   The Gnome Top Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The Gnome Top Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <glibtop.h>
#include <glibtop/open.h>
#include <glibtop/close.h>
#include <glibtop/command.h>

/* Closes server. */

void
glibtop_close_r (glibtop *server)
{
	switch (server->method) {
	case GLIBTOP_METHOD_UNIX:
	case GLIBTOP_METHOD_INET:
		glibtop_call_l (server, GLIBTOP_CMND_QUIT,
				0, NULL, 0, NULL);

		if (close (server->socket))
			glibtop_warn_io ("close");

		break;
	case GLIBTOP_METHOD_PIPE:
		kill (server->pid, SIGKILL);
		close (server->input [0]);
		close (server->output [1]);
		break;
	}
}
